;;; DCL Tutorial
;;; Subject: Creating a ProgressBar in DCL.
;;; This Tutorial is CopyRighted by Nir sullam and anySOFT 1999.

(defun C:PROGRESS (/ loopmax dcltut_dat)
	(setq dcltut_dat (load_dialog "c:\\dcltut.dcl"))
	(new_dialog "dcltut" dcltut_dat)
	;; if no maximum is set -Set the default to 100.
	(if	(null loopmax)(setq loopmax 100))
	;; color the image tile  with the background color
	(setq fillx (dimx_tile "progbar"))
	(setq filly (dimy_tile "progbar"))
	(start_image "progbar")
	(fill_image 0 0 fillx filly -15)
	(end_image)

	;; Set the edit_box tile to its value
	(set_tile "max" (itoa loopmax))

	;; Assign the loopfunc to the start button
	(action_tile "start" "(loopfunc)")
	(action_tile "ok" "(done_dialog)")
	(action_tile "cnacel" "(done_dialog)")
	(start_dialog)
	(UNLOAD_DIALOG dcltut_dat)
)


;----------------------------------------------

(defun loopfunc	(/ fillx filly loopfunc loopmax loop-counter)

	;; Get the Horizontal length of the "progbar" tile
	(setq fillx (dimx_tile "progbar"))
	;; Get the Vertical length of the "progbar" tile
	(setq filly (dimy_tile "progbar"))
	;; Start the tile
	(start_image "progbar")
	;; Initiate the -15 color as a background (-15 = Dialog Background  color)
	(fill_image 0 0 fillx filly -15)
	;; end the initializing
	(end_image)

	;; rewind the counter to 0
	(setq loop-counter 0)
	;; get the value that is used as the maximum limit for the progress bar
  ;; in your application you may use it to show the progressing of a function that 
  ;; processes a selction set so if your selection set length is 544 - the loopmax will have to 
  ;; be assigned the value 544.(instead of using an edit_box tile as I did in this example.)
	(setq loopmax (atoi (get_tile "max")))
	;; As long as the counter is smaller than the maximum - fill the tile
	(while (<= loop-counter loopmax)
		(start_image "progbar")

		;; The horizontal length is divided to "loopmax" times slices
		(fill_image 0 0 (/ (* loop-counter fillx) loopmax) filly 5)
		(end_image)
		;; print the advance in the error tile
		(set_tile "error" (rtos loop-counter))
		;; increment the counter
		(setq loop-counter (1+ loop-counter))
	)
)




